import React, { Component } from 'react';
import Highlight from './Highlight'
import { findTotalMatch, findTotalMatchExact } from './Highlight/utils/text'

const TEXT = 'I am a dummy react a npm module www.google.com'
export default class App extends Component {
  state = {
    currentIndex: 1,
    keyword: '',
    total: 0,
    // totalContain: 0,
    // totalExact: 0,
    mode: 'contain',
  }

  // changeMode = () => {
  //   const {mode} = this.state
  //   if(mode === 'contain'){
  //     this.setState({ mode: 'exact' })
  //   } else {
  //     this.setState({ mode: 'contain'})
  //   }
  // }
 
  changeKeyword = (e) => {
    const text = TEXT
    const value = e.target.value
    
    if (value.replace(/\s/g, '').length) {
      const total = this.findTotal(value, text)
      if(total === 0) {
        this.setState({ keyword: value, total: total, currentIndex: 0 })
      } else {
        this.setState({ keyword: value, total: total, currentIndex: 1 })
      }
    } else {
      this.setState({ keyword: '', total: 0, currentIndex: 1 })
    }
  }

  findTotal = (value, text) => {
    let total = 0
    const { mode } = this.state
      if(mode === 'contain') {
        total = findTotalMatch(value, text)
      } else {
        total = findTotalMatchExact(value, text)
      }
      return total
  }

  next = () => {
    const { total, currentIndex } = this.state
    if (total !== 0) {
      if (currentIndex === total) {
        this.setState({ currentIndex: 1 })
      } else {
        this.setState({ currentIndex: this.state.currentIndex + 1 })
      }
    }
  }

  prev = () => {
    const { total, currentIndex } = this.state
    // const { currentIndex, setCurrentIndex } = this.props
    if (total !== 0) {
      if (currentIndex === 1) {
        this.setState({ currentIndex: total })
        // setCurrentIndex(total)
      } else {
        this.setState({ currentIndex: this.state.currentIndex - 1 })
        // setCurrentIndex(total)
        // setCurrentIndex(currentIndex - 1)
      }
    }
  }


  render() {
    const text = TEXT
    // const keyword = 'x'
    const { mode, total } = this.state
    const aaa = findTotalMatch(this.state.keyword, text)
    // console.log('currentIndex', this.state.currentIndex)
    // console.log('this.state.keyword', this.state.keyword)
    // console.log('this.state.total', this.state.total)

    // console.log(total, 77777)
    return (
      <div>
        find {this.state.mode} <input onChange={this.changeKeyword} />
        <button onClick={this.changeMode}>change mode</button>
        {/* <button onClick={this.changeMode}>exact</button> */}
        <Highlight
          findMode={mode}
          text={text}
          keyword={this.state.keyword}
          currentIndex={this.state.currentIndex}
        />
        <button onClick={this.prev}>prev</button>
        <button onClick={this.next}>next</button>
      </div>
    )
  }
}
