import React from 'react'
import PropTypes from 'prop-types'
import HighlightContain from './HighlightContain'
import HightlightExact from './HighlightExact'
// import { CHAT_HISTORY_MODE } from '@/lib/constants/chatHistory'

const Highlight = ({
  findMode,
  text,
  keyword,
  currentIndex,
}) => {
  return (
    findMode === 'contain'
      ? (
        <HighlightContain
          text={text}
          keyword={keyword}
          currentIndex={currentIndex}
        />
      )
      : (
        <HightlightExact
          text={text}
          keywordExact={keyword}
          currentIndex={currentIndex}
        />
      )
  )
}

Highlight.propTypes = {
  findMode: PropTypes.string,
  text: PropTypes.string,
  keyword: PropTypes.string,
  currentIndex: PropTypes.number,
}

Highlight.defaultProps = {
  // findMode: CHAT_HISTORY_MODE.CONTAINS,
  text: '',
  keyword: '',
}

export default Highlight
