import React from 'react'
import classNames from 'classnames'
import { finalLink } from './text'
import '../index.scss'

const displayTextWithLinkWithHighlightWithFocus = (text, match, link, linkName, indexAt) => {
  const resultText = []
  let keyIndex = 0
  let temp = ''
  let current = -1
  let value = []
  match.forEach((item, index) => {
    value.push(parseInt(`${match[index]}${link[index]}${indexAt[index]}`, 2).toString(10))
    // m = has match, l = link, i = has index potision, ~ = not , [Y] = highlight yellow, [B] = highlight blue, [a] = <a/>
    // 0=000= ~(mli)      ,1=001= ~(ml)i [IMPOSSIBLE]  ,2=010 = ~ml~i [a]     ,3=011= ~mli [IMPOSSIBLE]
    // 4=100= m~(li) [Y]  ,5=101= m~li   [B]           ,6=110 = ml~i  [Y, a]  ,7=111= mli  [B, a]
    if (index === 0) {
      temp = text[index]
      current = value[index]
    } else if (value[index] === current) {
      temp = `${temp}${text[index]}`
    } else if (value[index] !== current) {
      resultText.push(
        <span
          key={keyIndex}
          className={classNames('text-highlight-no-modify', { 'text-highlight-content': ['4', '6'].includes(value[index - 1]) }, { 'text-focus-content': ['5', '7'].includes(value[index - 1]) })}>
          {
            ['2', '6', '7'].includes(value[index - 1]) ?
              <a href={finalLink(linkName[index - 1])} target="_blank" className="link-underline">{temp}</a>
              :
              temp
          }
        </span>
      )
      temp = text[index]
      current = value[index]
      keyIndex += 1
    }
    if (index === (match.length - 1)) {
      resultText.push(
        <span
          key={keyIndex}
          className={classNames('text-highlight-no-modify', { 'text-highlight-content': ['4', '6'].includes(value[index]) }, { 'text-focus-content': ['5', '7'].includes(value[index]) })}>
          {
            ['2', '6', '7'].includes(value[index]) ?
              <a href={finalLink(linkName[index])} target="_blank" className="link-underline">{temp}</a>
              :
              temp
          }
        </span>
      )
    }
  })
  return resultText
}

export default displayTextWithLinkWithHighlightWithFocus
