// import moment from 'moment'
// import _ from 'lodash'
// import { FULL_MONTH_FORMAT, TIME_FORMAT } from '@/lib/constants/global'

// export const groupByDate = (conversation) => {
//   return moment(parseInt(conversation.accepted_at, 10)).startOf('days').format('x')
// }

// export const countTotalCurrentMessage = chatMessages => _.flatten(Object.values(chatMessages)).length

export const convertNumberToIndex = (totalMatch, startIndex, currentIndex) => {
  let totalFoundIndex = startIndex - 1
  let totalFoundMatch = Array(totalMatch).fill().map(() => {
    totalFoundIndex += 1
    return totalFoundIndex
  })
  if (totalFoundMatch.includes(currentIndex)) {
    return (currentIndex - startIndex) + 1
  }
  return 0
}

export const findTotalMatch = (keyword, text) => {
  let resultCount = 0
  if (keyword) {
    const modifiedText = text.toLowerCase()
    const LowerCaseKeyword = keyword.toLowerCase()
    const trimedKeyword = LowerCaseKeyword.trim()
    const splitedKeywordList = trimedKeyword.split(new RegExp(/\s+/, 'gi'))
    let modifiedKeyword = [...new Set(splitedKeywordList)]
    modifiedKeyword.forEach((word) => {
      let startIndex = 0
      let foundIndex = -1
      do {
        foundIndex = modifiedText.indexOf(word, startIndex)
        if (foundIndex > -1) {
          startIndex = foundIndex + 1
          resultCount += 1
        }
      } while (foundIndex > -1)
    })
  }
  return resultCount
}

export const findTotalMatchExact = (word, text) => {
  const trimedKeyword = word.toLowerCase().trim()
  const modifiedText = text.toLowerCase()
  let resultCount = 0
  const wordLength = trimedKeyword.length
  const textLength = modifiedText.length
  let startIndex = 0
  let index = -1
  const spaces = [' ', '\n', '\t']
  if (word) {
    if (modifiedText === trimedKeyword) {
      resultCount += 1
    } else {
      index = modifiedText.indexOf(trimedKeyword, startIndex)
      while (index > -1) {
        if ((index === 0) && (spaces.includes(text[index + wordLength]))) { // start of content
          resultCount += 1
        } else if ((spaces.includes(modifiedText[index - 1])) && (spaces.includes(modifiedText[index + wordLength]))) { // middle of content
          resultCount += 1
        } else if ((spaces.includes(modifiedText[index - 1])) && (index + wordLength === textLength)) { // last of content
          resultCount += 1
        }
        startIndex = index + wordLength
        index = modifiedText.indexOf(trimedKeyword, startIndex)
      }
    }
  }
  return resultCount
}

// export const downloadFile = (filePath) => {
//   const downloadLink = document.createElement('a')
//   downloadLink.download = filePath.split('?')[0].split('/').slice(-1).toString()
//   downloadLink.id = 'download'
//   const xhr = new XMLHttpRequest()
//   xhr.onload = () => {
//     const reader = new FileReader()
//     reader.onloadend = () => {
//       downloadLink.href = reader.result
//       if (document.getElementById('download') === null) {
//         document.body.appendChild(downloadLink)
//         downloadLink.click()
//         downloadLink.remove()
//       }
//     }
//     reader.readAsDataURL(xhr.response)
//   }
//   xhr.open('GET', filePath)
//   xhr.responseType = 'blob'
//   xhr.send()
// }

// export const convertCallDetailDateTime = (callDetailDateTime) => {
//   return moment(parseInt(callDetailDateTime, 10)).format(`${FULL_MONTH_FORMAT} [at] ${TIME_FORMAT}`)
// }

export const initialList = (listLen, initialValue) => {
  return Array(listLen).fill(initialValue)
}

export const detectPartOfLink = text => ['http', 'www', '@'].some(i => text.includes(i))

export const getLinkUrl = (text, linkIndices) => {
  let linkName = Array(text.length).fill(0)
  let start = -1
  linkIndices.forEach((item, index) => {
    if (item === 1) {
      if (start === -1) {
        start = index
      }
      if (index === (linkIndices.length - 1)) {
        linkName.fill(text.substring(start), start)
      }
    } else if (item === 0) {
      linkName.fill(text.substring(start, index), start, index)
      start = -1
    }
  })
  return linkName
}

export const getIndicesOfLink = (text, linkIndices) => {
  const httpRegEx = /((https?:)\/\/[-a-zA-Z0-9&#=.\/?_%:()]+)/g
  const wwwRegEx = /((www)[-a-z0-9&#=.\/?_%:()]+)/g
  const emailRegEx = /(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/g
  const listPattern = [httpRegEx, wwwRegEx, emailRegEx]
  let urlResult
  listPattern.forEach((regEx) => {
    do {
      urlResult = regEx.exec(text)
      if (urlResult !== null) {
        const link = urlResult[0]
        const linkLen = link.length
        const foundIndex = regEx.lastIndex - linkLen
        linkIndices.fill(1, foundIndex, foundIndex + linkLen)
      }
    } while (urlResult !== null)
  })
  return linkIndices
}

export const orderChatIndex = (indexList) => {
  return indexList.sort((startIndex, length) => {
    if (startIndex[0] < length[0]) return -1
    if (startIndex[0] > length[0]) return 1
    if (startIndex[1] < length[1]) return -1
    if (startIndex[1] > length[1]) return 1
    return 0
  })
}

export const finalLink = (link) => {
  const emailRegEx = /(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/gi
  if (emailRegEx.exec(link) !== null) {
    return `mailto:${link}`
  } else if (link.substring(0, 4) === 'www.') {
    return `https://${link}`
  }
  return link
}
